using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

using MapApp.Model;

namespace MapApp.UI {
  public partial class FrmMain : Form {
    FrmOptions frmOptions = null;
    FrmFind frmFind = null;
    FrmAbout frmAbout = null;
    public static FrmMain Instance;

    static string mapFilePath = AppUtil.tempDir + "/map.html";
    static string pdmarkerFilePath = AppUtil.tempDir + "/pdmarker.js";

    public void SetStatusText(string value) {
      statusLabel.Text = value;
      //FrmMain._instance.BeginInvoke(SetStatusText, new object[]{value});
    }

    public FrmMain() {
      AppUtil.init(this);

      FrmMain.Instance = this;
      this.frmOptions = new FrmOptions();
      this.frmFind = new FrmFind();
      this.frmAbout = new FrmAbout();

      //// Copy the map.html & pdmarker.js files from resources to 
      AppUtil.writeResourceToDisk("MapApp.Resources.html.map.html", mapFilePath);
      AppUtil.writeResourceToDisk("MapApp.Resources.html.pdmarker.js", pdmarkerFilePath);

      InitializeComponent();
      //string exeDir = Application.ExecutablePath;

      webBrowser1.Url = new Uri(mapFilePath);
    }

    public void ZoomTo(MapLocation loc) {
      webBrowser1.Document.GetElementById("zoomToLat").InnerHtml = "" + loc.Lat;
      webBrowser1.Document.GetElementById("zoomToLng").InnerHtml = "" + loc.Lng;
      webBrowser1.Document.GetElementById("zoomToZoomLevel").InnerHtml = "" + loc.ZoomLevel;
      Object obj = webBrowser1.Document.GetElementById("zoomTo").DomElement;
      System.Reflection.MethodInfo mi = obj.GetType().GetMethod("click");
      mi.Invoke(obj, new object[0]);
    }

    private void exitToolStripMenuItem_Click(object sender, EventArgs e) {
      this.Hide();
      this.Dispose();
    }


    private void webBrowser1_ProgressChanged(object sender, WebBrowserProgressChangedEventArgs e) {

      //// Rats, this doesn't work....
      //if (e.CurrentProgress < e.MaximumProgress)
      //{
      //    this.Cursor = Cursors.WaitCursor;
      //}
      //else
      //{
      //    //this.Cursor = Cursors.Default;
      //}
    }

    private void optionsToolStripMenuItem_Click(object sender, EventArgs e) {
      frmOptions.Show();

    }

    private void aboutToolStripMenuItem_Click(object sender, EventArgs e) {
      frmAbout.Show();
    }

    private void findToolStripMenuItem_Click(object sender, EventArgs e) {
      frmFind.Show();
    }

    private void FrmMain_FormClosing(object sender, FormClosingEventArgs e) {
      this.Hide();
      frmFind.SaveHistoryFile();
    }

  }
}