using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace MapApp.Model
{
    [Serializable]
    public class MapLocationCollection : BindingList<MapLocation>
    {

    }

    [Serializable]
    public class MapLocation
    {
        Guid _id;
        double _lat;
        double _lng;
        int _zoomLevel;
        string _label;
        string _description;
        string _locationString;
        Uri _url;

        public MapLocation(string locationString, double lat, double lng)
        {
            this.LocationString = locationString;
            this.Lat = lat;
            this.Lng = lng;
        }

        public MapLocation(string locationString, double lat, double lng, int zoomLevel)
        {
            this.LocationString = locationString;
            this.Lat = lat;
            this.Lng = lng;
            this.ZoomLevel = zoomLevel;
        }

        public Guid Id
        {
            get { return _id; }
            set { _id = value; }
        }

        public string Label
        {
            get { return _label; }
            set { _label = value; }
        }

        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }

        public Uri Url
        {
            get { return _url; }
            set { _url = value; }
        }


        public String LocationString
        {
            get { return _locationString; }
            set { _locationString = value; }
        }

        public double Lat
        {
            get { return _lat; }
            set { _lat = value; }
        }

        public double Lng
        {
            get { return _lng; }
            set { _lng = value; }
        }

        public int ZoomLevel
        {
            get { return _zoomLevel; }
            set { _zoomLevel = value; }
        }

    }
}
