using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.IO;

using System.Windows.Forms;



namespace MapApp.UI
{
    class AppUtil
    {
        public static string tempDir = System.IO.Path.GetTempPath() + "map";

        public static FrmMain frmMain = null;  // set in init()

        public static bool init(FrmMain frmMain)
        {
            AppUtil.frmMain = frmMain;

            //// create our temp directory:
            Directory.CreateDirectory(AppUtil.tempDir);
            // Copy the stylesheet to temp directory:
            writeResourceToDisk("MapApp.Resources.html.style.css", AppUtil.tempDir + "/style.css");

            return true;
        }

        /// <summary>
        /// Writes a resource to the specified filepath. Overwrites whatever was there before.
        /// </summary>
        /// <param name="resourceName"></param>
        /// <param name="filePath"></param>
        public static void writeResourceToDisk(string resourceName, string filePath)
        {
            Assembly asm = frmMain.GetType().Assembly;

            //string[] resourceNames = asm.GetManifestResourceNames();

            Stream s = asm.GetManifestResourceStream(resourceName);
            // Read resource into a buffer:
            int len = (int)s.Length;
            byte[] buffer = new byte[len];
            s.Read(buffer, 0, len);
            s.Close();
            // Write the buffer to disk:
            FileStream fs = File.Create(filePath, len);
            fs.Write(buffer, 0, len);
            fs.Close();
        }


    }
}
