﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using MapApp.Model;

namespace MapApp.UI.Controls
{
    public partial class GoogleMapControl : WebBrowser
    {
        public GoogleMapControl()
        {
            InitializeComponent();
            CustomInitialize();
        }

        public GoogleMapControl(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
            CustomInitialize();
        }

        private void CustomInitialize() {

        }

        //void Document_MouseDown(object sender, HtmlElementEventArgs e)
        //{
        //    MessageBox.Show("down" + ", x: " + e.MousePosition.X + ", Y: " + e.MousePosition.Y);
        //}

        void Document_MouseMove(object sender, HtmlElementEventArgs e)
        {
            string msg = "move" + ", x: " + e.MousePosition.X + ", Y: " + e.MousePosition.Y;
            //MessageBox.Show(msg);
            AppUI.CoordText = msg;
        }



        public void ZoomTo(MapLocation loc)
        {
            Object[] objArray = { loc.Lat, loc.Lng, loc.ZoomLevel };
            Document.InvokeScript("zoomTo", objArray);
        }

        public void SetOverviewMapVisible(bool visible)
        {
            Object[] objArray = { visible };
            Document.InvokeScript("setOverviewMapVisible", objArray);
        }

        public void SetScaleBarVisible(bool visible)
        {
            Object[] objArray = { visible };
            Document.InvokeScript("setScaleBarVisible", objArray);
        }

        public void NewMarker(MapLocation loc, string toolTip)
        {
            Object[] objArray = { loc.Lat, loc.Lng, toolTip };
            Document.InvokeScript("newMarker", objArray);
        }



        private void GoogleMapControl_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            //Document.MouseDown += new HtmlElementEventHandler(Document_MouseDown);
            Document.MouseMove += new HtmlElementEventHandler(Document_MouseMove);
            //Document.AttachEventHandler("mousemove", new EventHandler(Document_MouseMove));
        }

    }
}
