using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

using MapApp.Model;

namespace MapApp.UI
{
    public partial class FrmMain : Form
    {
        FrmMarkers frmMarkers = null;
        FrmOptions frmOptions = null;
        FrmFind frmFind = null;
        FrmAbout frmAbout = null;
        public static FrmMain Instance;

        static string mapFilePath = AppUtil.tempDir + "/map.html";
        static string pdmarkerFilePath = AppUtil.tempDir + "/pdmarker.js";

        public void SetStatusText(string value)
        {
            statusLabel.Text = value;
        }

        public void SetCoordText(string value)
        {
            coordLabel.Text = value;
        }

        public FrmMain()
        {
            AppUtil.init(this);

            FrmMain.Instance = this;
            ////this.frmOptions = new FrmOptions();
            this.frmFind = new FrmFind();
            this.frmAbout = new FrmAbout();

            //// Copy the map.html & pdmarker.js files from resources to 
            AppUtil.writeResourceToDisk("MapApp.Resources.html.map.html", mapFilePath);
            AppUtil.writeResourceToDisk("MapApp.Resources.html.pdmarker.js", pdmarkerFilePath);

            InitializeComponent();
            //string exeDir = Application.ExecutablePath;

            googleMapControl1.Url = new Uri(mapFilePath);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Hide();
            this.Dispose();
        }



        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (frmOptions == null)
            {
                frmOptions = new FrmOptions();
            }
            frmOptions.Show();

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout.Show();
        }

        private void findToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmFind.Show();
        }

        private void FrmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            if (frmAbout != null)
            {
                frmAbout.Hide();
                frmAbout.Dispose();
            }
            if (frmOptions != null)
            {
                frmOptions.Hide();
                frmOptions.Dispose();
            }
            if (frmFind != null)
            {
                frmFind.Hide();
                frmFind.SaveHistoryFile();
                frmFind.Dispose();
            }
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Bitmap bmp = new Bitmap(googleMapControl1.Width, googleMapControl1.Height);
            googleMapControl1.DrawToBitmap(bmp, new Rectangle(googleMapControl1.Location.X, googleMapControl1.Location.Y, 
                googleMapControl1.Width, googleMapControl1.Height));

            Form dummy = new Form();
            dummy.BackgroundImage = bmp;
            dummy.Show();
        }

        private void markersToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (frmMarkers == null)
            {
                frmMarkers = new FrmMarkers();
            }
            frmMarkers.Show();
        }

    }
}